from axipy import data_manager, TypeSqlDialect, MultiLineString, GeometryCollection


def multiLineStringToCollection(geo_multi):
    geo_collection = GeometryCollection()
    count_polyline = len(geo_multi)
    for i in range(count_polyline):
        geo_collection.append(geo_multi[count_polyline-i-1])
    return geo_collection
def findIntersections(tab_name,name_id,value_id):
    sql_format_base_patern="select * from {name} where {name}.{id}={id_value}"
    sql_format_base=sql_format_base_patern.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_patern_next="select * from {name} where {name}.{id}>{id_value}"
    sql_next=sql_patern_next.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_full_patern="select t.{id} as parent_id,t_base.{id} as children_id,t_base.obj as obj from ({sql_1}) as t ,({sql_2}) as t_base where t.obj  Intersects t_base.obj"
    sql_full=sql_full_patern.format(id=name_id,sql_1=sql_format_base,sql_2=sql_next)
    query = data_manager.query(sql_full, TypeSqlDialect.sqlite)
    return query

def updateGeometryFeature(name_table,name_id,id_value,geo_update):
    sql="Select * From "+name_table+" where "+name_id+"="+str(id_value)
    query_tab_update=data_manager.query(sql,TypeSqlDialect.axioma)
    fts=list(query_tab_update.items())
    ft=fts[0]
    ft.geometry=geo_update
    query_tab_update.update([ft])
    #query_tab_update.close()
def updateGeometryFeatureBase(table_base,id_value,geo_update):
    fts=list(table_base.itemsByIds([id_value]))
    ft=fts[0]
    ft.geometry=geo_update
    table_base.update([ft])
def getGeometryByIdFeature(table,id):
    fts = list(table.itemsByIds([id]))
    ft = fts[0]
    return ft.geometry
def SplitIntersection(table,query_tab,name_id,parent_id):
    base_geometry=getGeometryByIdFeature(table,parent_id)
    geo_parent=base_geometry.clone()

    for ft in query_tab.items():

        geo_parent=geo_parent.split_by_polyline(ft.geometry)
        #child_geo=ft.geometry.split_by_polyline(base_geometry)
        child_geo=getGeometryByIdFeature(table,ft['children_id'])
        child_geo = child_geo.split_by_polyline(base_geometry)
        is_multiLineString=isinstance(child_geo,MultiLineString)
        if is_multiLineString:
            child_geo=multiLineStringToCollection(child_geo)
        updateGeometryFeatureBase(table,ft['children_id'],child_geo)

    #updateGeometryFeature(table.name,name_id,parent_id,geo_parent)
    is_multiLineString = isinstance(geo_parent, MultiLineString)
    if is_multiLineString:
        geo_parent = multiLineStringToCollection(geo_parent)
    updateGeometryFeatureBase(table, parent_id,geo_parent)
    geo_parent=None
def OvershotClip(name_base_tab,name_id):
    ''' Поиск пересечений и разрыв в точках пересечений'''
    tab_base=data_manager.find(name_base_tab)
    for ft in tab_base.items():
        id_val=ft[name_id]
        #base_geometry=ft.geometry.clone()
        if ft.geometry is None:
            continue
        query=findIntersections(name_base_tab,name_id,id_val)
        if query.count()==0:
            query.close()
        SplitIntersection(tab_base,query,name_id,id_val)
        query.close()
        #break
#name_q_1=findIntersections(name_tab,"id",1)
#name_q_2=findIntersections(name_tab,"id",2)
name_tab='Test_1'
base_query_sql="Select rowid as id___base,* From "+name_tab
base_query=data_manager.query(base_query_sql,TypeSqlDialect.sqlite)
OvershotClip(base_query.name,"id___base")
'''
tab=data_manager.find(name_tab)
for ft in tab.items():
    print(ft.id)
'''
print("End")
