from axipy import Feature, data_manager, TypeSqlDialect, MultiLineString


class CacheTable:
    def __init__(self,table,sizeCache=500):
        self.__tab=table
        self.__cache=[]
        self.__cache_size=sizeCache
    def insert(self,ft):
        self.__cache.append(ft)
        if len(self.__cache)>=self.__cache_size:
            self.__tab.insert(self.__cache)
            self.__cache.clear()
        return
    def end(self):
        if len(self.__cache)>0:
            self.__tab.insert(self.__cache)
            self.__cache.clear()

def FeatureClone(ft:Feature,new_geo):
    attr_temp=ft.items()
    attr= {}
    for att in attr_temp:
        if att[0]=='+geometry' or att[0]=='+style':
            continue
        attr[att[0]]=att[1]

    return Feature(attr,geometry=new_geo,style=ft.style)

def UnGroupObject(name_tab):
    sql="Select GeometryType(FromAxiGeo(obj)) as name_geo, * from "+name_tab+' where GeometryType(FromAxiGeo(obj))="GEOMETRYCOLLECTION" or GeometryType(FromAxiGeo(obj))= "MULTILINESTRING"'
    query_tab_update = data_manager.query_hidden(sql, TypeSqlDialect.sqlite)
    tab_base = data_manager.find(name_tab)
    list_remove=[]
    cls_cache=CacheTable(tab_base)
    for ft in query_tab_update.items():
        list_remove.append(ft.id)
        count_polyline=len(ft.geometry)
        #list_features_new=[]
        for i in range(count_polyline):
            ft_new=FeatureClone(ft,ft.geometry[i])
            print(ft_new.geometry.name)
            #list_features_new.append(ft_new)
            cls_cache.insert(ft_new)
        #tab_base.insert(list_features_new)
    cls_cache.end()
    query_tab_update.close()

    tab_base.remove(list_remove)
def UnGroupObjectNone(name_tab):
    sql="Select GeometryType(FromAxiGeo(obj)) as name_geo, * from "+name_tab+' where GeometryType(FromAxiGeo(obj))="GEOMETRYCOLLECTION" or GeometryType(FromAxiGeo(obj))= "MULTILINESTRING"'
    query_tab_update = data_manager.query_hidden(sql, TypeSqlDialect.sqlite)
    tab_base = data_manager.find(name_tab)
    list_remove=[]
    cls_cache=CacheTable(tab_base)
    for ft in query_tab_update.items():
        list_remove.append(ft.id)

        count_polyline=len(ft.geometry)
        print(ft.geometry.type)

        for i in range(count_polyline):
            ft_new=FeatureClone(ft,ft.geometry[i])

            cls_cache.insert(ft_new)

    cls_cache.end()

    update_features=[]
    for ft_del in query_tab_update.itemsByIds(list_remove):
        ft_del.geometry=None
        update_features.append(ft_del)
        #query_tab_update.update([ft_del])
    #tab_base.remove(list_remove)
    query_tab_update.update(update_features)
    query_tab_update.close()
    sql_del='Delete From '+name_tab+' where ObjInfoType(obj)=0'
    query_del=data_manager.query_hidden(sql_del, TypeSqlDialect.axioma)
    query_del.close()
def UnGroupObjectSlow(name_tab):
    table=data_manager.find(name_tab)
    list_remove = []
    cls_cache = CacheTable(table)
    for ft in table.items():
        if ft.geometry is None:
            continue
        if not isinstance(ft.geometry,MultiLineString):
            continue
        list_remove.append(ft.id)
        count_polyline = len(ft.geometry)

        for i in range(count_polyline):
            ft_new = FeatureClone(ft, ft.geometry[i])
            cls_cache.insert(ft_new)
    cls_cache.end()
    table.remove(list_remove)
name_table='test_underShot_collection'
UnGroupObjectNone(name_table)