import axipy
from axipy import data_manager, TypeSqlDialect, Line, LineString, LinearUnit, Point
from datetime import datetime
def findObjectForUnderShotPointId(name_table,name_id,value_id,dist:axipy.cs.UnitValue,number_point,type_point):
    sql_1 = "Select "+name_id+","+str(type_point)+" as type_point_zx,ToAxiGeo(Buffer(PointN(FromAxiGeo(obj),"+str(number_point)+"),"+str(dist.value)+")) as obj from " + name_table + " where " + name_id + "=" + str(value_id)
    sql_2 = "Select * from " + name_table + " where " + name_id + "<>" + str(value_id)
    sql_base ="Select paretn_t."+name_id+",curent_t.type_point_zx from ("+sql_1+") as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query_pnt = data_manager.query_hidden(sql_1, TypeSqlDialect.sqlite)
    sql_base="Select  paretn_t."+name_id+",curent_t.type_point_zx from " +query_pnt.name+" as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query = data_manager.query_hidden(sql_base, TypeSqlDialect.sqlite)
    query_pnt.close()
    out_id_objs=None
    if query.count()>0:
        out_id_objs=[]
        for ft in query.items():
            out_id_objs.append({"id":ft[name_id],"point_type":type_point})
    query.close()
    return out_id_objs
def findObjectForUnderShotPointIdNoSql(table,name_id,value_id,dist:axipy.cs.UnitValue,geo_point,type_point):
    '''
    sql_1 = "Select "+name_id+","+str(type_point)+" as type_point_zx,ToAxiGeo(Buffer(PointN(FromAxiGeo(obj),"+str(number_point)+"),"+str(dist.value)+")) as obj from " + name_table + " where " + name_id + "=" + str(value_id)
    sql_2 = "Select * from " + name_table + " where " + name_id + "<>" + str(value_id)
    sql_base ="Select paretn_t."+name_id+",curent_t.type_point_zx from ("+sql_1+") as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query_pnt = data_manager.query_hidden(sql_1, TypeSqlDialect.sqlite)
    sql_base="Select  paretn_t."+name_id+",curent_t.type_point_zx from " +query_pnt.name+" as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query = data_manager.query_hidden(sql_base, TypeSqlDialect.sqlite)
    query_pnt.close()
    '''
    out_id_objs = []
    buffer_point=geo_point.buffer(dist.value)
    for ft in table.items(buffer_point.bounds):
        if ft[name_id]==value_id:
            continue
        if not ft.geometry.intersects(buffer_point):
            continue
        out_id_objs.append({"id":ft[name_id],"point_type":type_point})

    if len(out_id_objs)==0:
        return None
    return out_id_objs
def findObjectForUnderShotNoSql(table,name_id,value_id,dist:axipy.cs.UnitValue,geo_curent):
    count_points=0
    if isinstance(geo_curent,Line):
        count_points=2
        start_point = Point(geo_curent.begin.x, geo_curent.begin.y, geo_curent.coordsystem)
        end_point = Point(geo_curent.end.x, geo_curent.end.y,
                          geo_curent.coordsystem)
    if isinstance(geo_curent,LineString):
        count_points=len(geo_curent.points)
        start_point = Point(geo_curent.points[0].x, geo_curent.points[0].y, geo_curent.coordsystem)
        end_point = Point(geo_curent.points[count_points - 1].x, geo_curent.points[count_points - 1].y,
                          geo_curent.coordsystem)
    if count_points==0:
        return None

    points_id_start=findObjectForUnderShotPointIdNoSql(table,name_id,value_id,dist,start_point,0)

    points_id_end = findObjectForUnderShotPointIdNoSql(table, name_id, value_id, dist, end_point, 1)
    list_id_point=[]
    if points_id_start is not None:
        list_id_point.extend(points_id_start)
    if points_id_end is not None:
        list_id_point.extend(points_id_end)
    if len(list_id_point)==0:
        return None
    return list_id_point
def findObjectForUnderShot(name_table,name_id,value_id,dist:axipy.cs.UnitValue,geo_curent):
    count_points=0
    if isinstance(geo_curent,Line):
        count_points=2
    if isinstance(geo_curent,LineString):
        count_points=len(geo_curent.points)
    if count_points==0:
        return None
    points_id_start=findObjectForUnderShotPointId(name_table,name_id,value_id,dist,1,0)
    points_id_end = findObjectForUnderShotPointId(name_table, name_id, value_id, dist, count_points, 1)
    list_id_point=[]
    if points_id_start is not None:
        list_id_point.extend(points_id_start)
    if points_id_end is not None:
        list_id_point.extend(points_id_end)
    if len(list_id_point)==0:
        return None
    return list_id_point
name_table='StreetGSK7_v_test_no_poligon_v2_over_shot'
sql_prepare = "Select RowNum() as id___dxx,* From " + name_table
name_id='id___dxx'
tab_id=data_manager.query(sql_prepare,TypeSqlDialect.sqlite)
tab_base = tab_id
count_row=tab_base.count()
i=0
start_time=datetime.now()
count_lim=100
dist=axipy.cs.UnitValue(4,LinearUnit.m)
for ft in tab_base.items():
    i=i+1
    if i>count_lim:
        break
    id_val = ft[name_id]
    obj_under=findObjectForUnderShotNoSql(tab_base,name_id,id_val,dist,ft.geometry)
    ()
tab_id.close()
end_time=datetime.now()
print("Time find:"+str(end_time-start_time))
