import axipy
from axipy import data_manager, TypeSqlDialect, Line, LineString, Geometry, Point

from Undershot.ui.addTools.helper import getGeometryByIdFeature, getFeatureById


def getGetSegment(base_geometry,type_point,distance):
    pnts=None
    if isinstance(base_geometry,Line):
        pnts=[base_geometry.begin,base_geometry.end]
    if isinstance(base_geometry,LineString):
        pnts=base_geometry.points
    if pnts is None:
        return None
    geo_segment_last=None
    if type_point==0:
        ''' начальная точка '''

        dist,azimuth=Geometry.distance_by_points(pnts[1],pnts[0],base_geometry.coordsystem)
        pnt_new=Geometry.point_by_azimuth(pnts[0],azimuth,distance)
        pnts_new=[pnts[0],pnt_new]
        geo_segment_last=LineString(pnts[1],pnts[0],base_geometry.coordsystem)
    else:
        n=len(pnts)
        dist, azimuth = Geometry.distance_by_points(pnts[n-2], pnts[n-1], base_geometry.coordsystem)
        pnt_new = Geometry.point_by_azimuth(pnts[n-1],  azimuth,distance)
        pnts_new = [pnts[n-1], pnt_new]
        geo_segment_last = LineString(pnts[n-2], pnts[n-1], base_geometry.coordsystem)
    segment_geo=LineString(pnts_new,base_geometry.coordsystem)
    return segment_geo,geo_segment_last
def addPoint(geo_children,geo_point,type_point):

    if type_point==0:
        geo_children.points.insert(0,(geo_point.x,geo_point.y))
    else:
        geo_children.points.append((geo_point.x, geo_point.y))
    return geo_children
def findApplicantUndefShot(name_table,name_id,value_id,dist:axipy.cs.UnitValue,coef_dist):
    ''' Поиск ближайших ( на расстоянии меньше заданного )'''
    sql_1="Select * from "+name_table+" where "+name_id+"="+str(value_id)
    sql_2="Select * from "+name_table+" where "+name_id+"<>"+str(value_id)
    #sql_base='Select t_base.*,ObjectDistance(t_base.obj,cur_t.obj,"'+dist.unit.name+'") as axi_dist From ('+sql_1+') as cur_t'
    sql_base = 'Select cur_t.'+name_id+' as parent__id,t_base.*,Distance(t_base.obj,cur_t.obj,"' + dist.unit.name + '") as axi_dist From (' + sql_1 + ') as cur_t'
    sql_base=sql_base+",("+sql_2+") as t_base where axi_dist<"+str(dist.value*coef_dist)+" order by axi_dist"
    query=data_manager.query(sql_base,TypeSqlDialect.sqlite)
    return query
def findObjectForUnderShotPointId(name_table,name_id,value_id,dist:axipy.cs.UnitValue,number_point,type_point):
    sql_1 = "Select "+name_id+","+str(type_point)+" as type_point_zx,ToAxiGeo(Buffer(PointN(FromAxiGeo(obj),"+str(number_point)+"),"+str(dist.value)+")) as obj from " + name_table + " where " + name_id + "=" + str(value_id)
    sql_2 = "Select * from " + name_table + " where " + name_id + "<>" + str(value_id)
    sql_base ="Select paretn_t."+name_id+",curent_t.type_point_zx from ("+sql_1+") as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query_pnt = data_manager.query_hidden(sql_1, TypeSqlDialect.sqlite)
    sql_base="Select  paretn_t."+name_id+",curent_t.type_point_zx from " +query_pnt.name+" as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query = data_manager.query_hidden(sql_base, TypeSqlDialect.sqlite)
    query_pnt.close()
    out_id_objs=None
    if query.count()>0:
        out_id_objs=[]
        for ft in query.items():
            out_id_objs.append({"id":ft[name_id],"point_type":type_point})
    query.close()
    return out_id_objs
def findObjectForUnderShotPointIdNoSql(table,name_id,value_id,dist:axipy.cs.UnitValue,geo_point,type_point):
    '''
    sql_1 = "Select "+name_id+","+str(type_point)+" as type_point_zx,ToAxiGeo(Buffer(PointN(FromAxiGeo(obj),"+str(number_point)+"),"+str(dist.value)+")) as obj from " + name_table + " where " + name_id + "=" + str(value_id)
    sql_2 = "Select * from " + name_table + " where " + name_id + "<>" + str(value_id)
    sql_base ="Select paretn_t."+name_id+",curent_t.type_point_zx from ("+sql_1+") as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query_pnt = data_manager.query_hidden(sql_1, TypeSqlDialect.sqlite)
    sql_base="Select  paretn_t."+name_id+",curent_t.type_point_zx from " +query_pnt.name+" as curent_t,("+sql_2+") as paretn_t where paretn_t.obj  Intersects curent_t.obj"
    query = data_manager.query_hidden(sql_base, TypeSqlDialect.sqlite)
    query_pnt.close()
    '''
    out_id_objs = []
    buffer_point=geo_point.buffer(dist.value)
    for ft in table.items(buffer_point.bounds):
        if ft[name_id]==value_id:
            continue
        if not ft.geometry.intersects(buffer_point):
            continue
        out_id_objs.append({"id":ft[name_id],"point_type":type_point})

    if len(out_id_objs)==0:
        return None
    return out_id_objs
def findObjectForUnderShotNoSql(table,name_id,value_id,dist:axipy.cs.UnitValue,geo_curent):
    count_points=0
    if isinstance(geo_curent,Line):
        count_points=2
        start_point = Point(geo_curent.begin.x, geo_curent.begin.y, geo_curent.coordsystem)
        end_point = Point(geo_curent.end.x, geo_curent.end.y,
                          geo_curent.coordsystem)
    if isinstance(geo_curent,LineString):
        count_points=len(geo_curent.points)
        start_point = Point(geo_curent.points[0].x, geo_curent.points[0].y, geo_curent.coordsystem)
        end_point = Point(geo_curent.points[count_points - 1].x, geo_curent.points[count_points - 1].y,
                          geo_curent.coordsystem)
    if count_points==0:
        return None

    points_id_start=findObjectForUnderShotPointIdNoSql(table,name_id,value_id,dist,start_point,0)

    points_id_end = findObjectForUnderShotPointIdNoSql(table, name_id, value_id, dist, end_point, 1)
    list_id_point=[]
    if points_id_start is not None:
        list_id_point.extend(points_id_start)
    if points_id_end is not None:
        list_id_point.extend(points_id_end)
    if len(list_id_point)==0:
        return None
    return list_id_point

def findObjectForUnderShot(name_table,name_id,value_id,dist:axipy.cs.UnitValue,geo_curent):
    count_points=0
    if isinstance(geo_curent,Line):
        count_points=2
    if isinstance(geo_curent,LineString):
        count_points=len(geo_curent.points)
    if count_points==0:
        return None
    points_id_start=findObjectForUnderShotPointId(name_table,name_id,value_id,dist,1,0)
    points_id_end = findObjectForUnderShotPointId(name_table, name_id, value_id, dist, count_points, 1)
    list_id_point=[]
    if points_id_start is not None:
        list_id_point.extend(points_id_start)
    if points_id_end is not None:
        list_id_point.extend(points_id_end)
    if len(list_id_point)==0:
        return None
    return list_id_point
class UnderShotItem:
    __coef_distance=10
    def __init__(self,table,name_id,distance:axipy.cs.UnitValue):
        self.__table=table
        self.__name_id=name_id
        self.__distance=distance

    def find(self,ft):

        #list_ids = findObjectForUnderShot(self.__table.name, self.__name_id,ft[self.__name_id], self.__distance, ft.geometry)
        list_ids = findObjectForUnderShotNoSql(self.__table, self.__name_id, ft[self.__name_id], self.__distance,
                                          ft.geometry)
        return list_ids
    def solver(self,parent_ft,list_id):
        ''' решение проблеммы недоводов'''

        parent_id=parent_ft[self.__name_id]
        parent_geometry=getGeometryByIdFeature(self.__table,parent_id)
        #start_segment,start_last_segment=getGetSegment(parent_geometry,0,self.__distance.value)
        #end_segment,end_last_segment = getGetSegment(parent_geometry, 1,self.__distance.value)
        for pnt_under_shot in list_id:
            children_id=pnt_under_shot['id']
            type_point=pnt_under_shot["point_type"]
            #geo_temp=start_segment
            #previous_segment=start_last_segment
            if type_point==1:
                end_segment, end_last_segment = getGetSegment(parent_geometry, 1, self.__distance.value)
                geo_temp=end_segment
                previous_segment=end_last_segment
            else:
                start_segment, start_last_segment = getGetSegment(parent_geometry, 0, self.__distance.value)
                geo_temp=start_segment
                previous_segment=start_last_segment
            geo_children=getGeometryByIdFeature(self.__table,children_id)
            if geo_children.intersects(previous_segment):
                continue
            geo_intersect=geo_children.intersection(geo_temp)
            if geo_intersect is not None and isinstance(geo_intersect,Point):
                ''' Точно не довод '''
                new_geo=addPoint(parent_geometry,geo_intersect,type_point)

                parent_ft.geometry=new_geo
                parent_geometry=new_geo
                self.__table.update([parent_ft])
                #print("UnnderShot id= "+str(parent_id))
                continue
            ()

class UnderShot:
    def __init__(self,table,name_id):
        self.__table=table
        self.__name_id=name_id

    def run(self,distanse_under_shot:axipy.cs.UnitValue):
        self.__distanse=distanse_under_shot
        self.__clsItem = UnderShotItem(self.__table,self.__name_id,distanse_under_shot)
        for ft in self.__table.items():
            if ft.geometry is None:
                continue
            list_id_children=self.__clsItem.find(ft)
            if list_id_children is None:
                continue
            self.__clsItem.solver(ft,list_id_children)


