import axipy
from axipy import data_manager, SelectionTable


def factoryObserverUnderOverShot(name_observer):
    observer = None
    try:
        observer = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer is not None:
        return observer
    observer=axipy.ObserverManager.create(name_observer,False)
    def change_data_sources():
        if len(data_manager.tables)==0:
            observer.value=False
            return
        count_tab_editbale=0
        for tab in data_manager.tables:
            if isinstance(tab,SelectionTable) :
                continue
            if (not tab.is_spatial) or ( not tab.is_editable) or tab.coordsystem.lat_lon :
                continue
            count_tab_editbale=count_tab_editbale+1

        if count_tab_editbale>0:
            observer.value = True
            return
        observer.value = False
        return

    setattr(observer, "change_data_manager", change_data_sources)
    data_manager.updated.connect(observer.change_data_manager)
    #data_manager.removed.connect(observer.change_data_manager)
    #data_manager.added.connect(observer.change_data_manager)
    observer.change_data_manager()
    return observer
def factoryObserverCreatePolygon(name_observer,parent_observer):
    observer = None
    try:
        observer = axipy.ObserverManager.get(name_observer)
    except:
        pass
    if observer is not None:
        return observer
    observer = axipy.ObserverManager.create(name_observer, parent_observer.value)
    def changeSelectionPoly():
        if not parent_observer.value:
            observer.value=False
            return
        if data_manager.selection.count()>=3:
            observer.value = True
            return
        if data_manager.selection.count()==2:
            list_feature=list(data_manager.selection.items())
            if list_feature[0].geometry.type!=axipy.GeometryType.Point or list_feature[1].geometry.type!=axipy.GeometryType.Point:
                observer.value = True
                return
        observer.value = False
        return
    setattr(observer, "change_selection", changeSelectionPoly)
    parent_observer.changed.connect(observer.change_selection)
    axipy.gui.selection_manager.changed.connect(observer.change_selection)
    return observer

