from axipy import TypeSqlDialect, data_manager, Feature, LinearUnits, LinearUnit, MultiPolygon, Polygon


def findIntersectionsNoSql(table,ft_curent,name_id,id_val):
    cur_geometry=ft_curent.geometry
    list_id=[]
    for ft in table.items(cur_geometry.bounds):
        if ft[name_id]<=id_val:
            continue
        obj_intersect= cur_geometry.intersects(ft.geometry)
        if not obj_intersect:
            continue
        list_id.append({'children_id':ft[name_id],'geometry':ft.geometry})
    return list_id
def SplitIntersectionNoSql(table,list_id_intersect,parent_id):

    base_geometry=getGeometryByIdFeature(table,parent_id)
    if base_geometry is None:
        return
    if isinstance(base_geometry,MultiPolygon) or isinstance(base_geometry,Polygon):
        geo_parent=base_geometry.to_linestring()
    else:
        geo_parent=base_geometry.clone()

    for ft in list_id_intersect:


        geo_parent=geo_parent.difference(ft['geometry'])

    updateGeometryFeatureBase(table, parent_id,geo_parent)
    geo_parent=None
    list_update_ft_id=[]
    for ft in list_id_intersect:
        child_geo = getGeometryByIdFeature(table, ft['children_id'])
        child_geo = child_geo.difference(base_geometry)
        list_update_ft_id.append({"id":ft['children_id'],"geometry":child_geo})
    if len(list_update_ft_id)>0:
        updateGeometryFeatureBaseArray(table,list_update_ft_id)
def getLinerUnit(locl_name):
    for item_unit in LinearUnits.items():
        if item_unit[1].localized_name==locl_name:
            return item_unit[1]
    return LinearUnit.m
class CacheTable:
    def __init__(self,table,sizeCache=500):
        self.__tab=table
        self.__cache=[]
        self.__cache_size=sizeCache
    def insert(self,ft):
        self.__cache.append(ft)
        if len(self.__cache)>=self.__cache_size:
            self.__tab.insert(self.__cache)
            self.__cache.clear()
        return
    def end(self):
        if len(self.__cache)>0:
            self.__tab.insert(self.__cache)
            self.__cache.clear()
def FeatureClone(ft:Feature,new_geo):
    attr_temp=ft.items()
    attr= {}
    for att in attr_temp:
        if att[0]=='+geometry' or att[0]=='+style':
            continue
        attr[att[0]]=att[1]

    return Feature(attr,geometry=new_geo,style=ft.style)
def getGeometryByIdFeature(table,id):
    fts = list(table.itemsByIds([id - 1]))
    if fts is None or len(fts)==0:
        return None
    ft = fts[0]
    return ft.geometry
def getFeatureByIdFeature(table,id):
    fts = list(table.itemsByIds([id - 1]))
    if fts is None or len(fts)==0:
        return None

    return fts[0]
def updateGeometryFeatureBaseArray(table_base,list_ft_updates):
    ft_update=[]
    for ft in list_ft_updates:
        ft_up=getFeatureByIdFeature(table_base,ft['id'])
        if ft_up is None:
            continue
        ft_up.geometry = ft['geometry']
        ft_update.append(ft_up)
    if len(ft_update)>0:
        table_base.update(ft_update)
def updateGeometryFeatureBase(table_base,id_value,geo_update):
    fts=list(table_base.itemsByIds([id_value-1]))
    ft=fts[0]
    ft.geometry=geo_update
    table_base.update([ft])

def SplitIntersection(table,query_tab,name_id,parent_id):
    base_geometry=getGeometryByIdFeature(table,parent_id)
    geo_parent=base_geometry.clone()
    '''
    if geo_parent is None:
        ()
    '''
    for ft in query_tab.items():

        #geo_parent=geo_parent.split_by_polyline(ft.geometry)
        '''
        if geo_parent is None:
            jkl=0
        '''
        geo_parent=geo_parent.difference(ft.geometry)
        #child_geo=ft.geometry.split_by_polyline(base_geometry)
        child_geo=getGeometryByIdFeature(table,ft['children_id'])
        if child_geo is None:
            ()
        #child_geo = child_geo.split_by_polyline(base_geometry)
        child_geo = child_geo.difference(base_geometry)
        '''
        is_multiLineString=isinstance(child_geo,MultiLineString)
        if is_multiLineString:
            child_geo=multiLineStringToCollection(child_geo)
        '''
        updateGeometryFeatureBase(table,ft['children_id'],child_geo)

    #updateGeometryFeature(table.name,name_id,parent_id,geo_parent)
    '''
    is_multiLineString = isinstance(geo_parent, MultiLineString)
    if is_multiLineString:
        geo_parent = multiLineStringToCollection(geo_parent)
    '''
    updateGeometryFeatureBase(table, parent_id,geo_parent)
    geo_parent=None
def findIntersections(tab_name,name_id,value_id):
    sql_format_base_patern="select * from {name} where {name}.{id}={id_value}"
    sql_format_base=sql_format_base_patern.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_patern_next="select * from {name} where {name}.{id}>{id_value}"
    sql_next=sql_patern_next.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_full_patern="select t.{id} as parent_id,t_base.{id} as children_id,t_base.obj as obj from ({sql_1}) as t ,({sql_2}) as t_base where t.obj  Intersects t_base.obj"
    sql_full=sql_full_patern.format(id=name_id,sql_1=sql_format_base,sql_2=sql_next)
    query = data_manager.query_hidden(sql_full, TypeSqlDialect.sqlite)
    return query