from time import sleep

from PySide2.QtCore import QObject, Signal
from axipy import data_manager, TypeSqlDialect

from Undershot.ui.process.addTools.helper_features import findIntersections, SplitIntersection, CacheTable, \
    FeatureClone, findIntersectionsNoSql, SplitIntersectionNoSql


class ProcessUnderOverShot(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar = Signal(str)
    finished = Signal(int)

    def __init__(self, params,parent_cls):
        super(ProcessUnderOverShot, self).__init__()
        self.__parent_cls = parent_cls
        self.__params = params
    def setParams(self,params):
        self.__params=params
    def run(self):
        list_process=self.__params['process']
        for item in list_process:
            isOk=item.run()
            if not isOk:
                break
        self.finished.emit(100)

class ProcessOverShot(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar = Signal(str)
    def __init__(self, params,parent_cls):
        super(ProcessOverShot, self).__init__()
        self.__parent_cls=parent_cls
        self.__params=params
        self.__old_val_progress_local = 0
        self.__name_process='Поиск пересечений '
        self.__cancelProcess=False
    def process_callback(self, complete_main):

        if self.IsCancel:
            return 0
        cur_progress_int = int(complete_main * 100 + 0.5)
        '''
        if cur_progress_int>self.__old_val_progress_local:
                self.__old_val_progress_local = cur_progress_int
                self.updateProcess.emit(complete_main * 100)
        '''
        self.updateProcess.emit(complete_main * 100)
        #time.sleep(0.001)
        # self.__parent.window.pr_bar.setValue(complete*100)
        # print(complete*100)
        return 1
    def prepareSignal(self,is_connect=True):
        try:
            self.__parent_cls.cancelProcess.disconnect(self.__isCancel)
        except Exception as ex:
            pass
        if is_connect:
            self.__parent_cls.cancelProcess.connect(self.__isCancel)
            self.__cancelProcess = False
    def prepareParentSignal(self,is_connect=True):
        try:
            self.updateProcess.disconnect(self.__parent_cls.update_progress)
        except Exception as ex:
            pass
        try:
            self.updateFormatProgressBar.disconnect(self.__parent_cls.setFormatprogressBar)
        except Exception:
            pass
        if not is_connect:
            self.updateProcess.connect(self.__parent_cls.update_progress)
            self.updateFormatProgressBar.connect(self.__parent_cls.setFormatprogressBar)
    @property
    def IsCancel(self):
        return self.__cancelProcess
    def run(self):
        name_table=self.__params['table']
        value_tolerance=self.__params['tolerance']
        self.prepareSignal(True)
        self.prepareParentSignal(False)
        self.updateFormatProgressBar.emit(self.__name_process+"... %p%")
        #sql_prepare="Select rowid+1 as id___dxx,* From "+name_table
        sql_prepare = "Select RowNum() as id___dxx,* From " + name_table
        name_id='id___dxx'
        tab_id=data_manager.query(sql_prepare,TypeSqlDialect.sqlite)
        is_cancel=0
        self.updateProcess.emit(0)
        self.__tab_base = tab_id
        count_row=self.__tab_base.count()
        i=0
        for ft in self.__tab_base.items():

            is_cancel=self.process_callback(i/count_row)



            i=i+1

            if is_cancel==0:
                break
            id_val = ft[name_id]
            if ft.geometry is None:
                continue
            lisi_id = findIntersectionsNoSql(self.__tab_base, ft, name_id, id_val)
            if len(lisi_id) == 0:
                continue
            SplitIntersectionNoSql(self.__tab_base, lisi_id,  id_val)
        tab_id.close()
        self.prepareSignal(False)
        self.prepareParentSignal(True)

        return is_cancel
    def run__old(self):
        name_table=self.__params['table']
        value_tolerance=self.__params['tolerance']
        self.prepareSignal(True)
        self.prepareParentSignal(False)
        self.updateFormatProgressBar.emit(self.__name_process+"... %p%")
        #sql_prepare="Select rowid+1 as id___dxx,* From "+name_table
        sql_prepare = "Select RowNum() as id___dxx,* From " + name_table
        name_id='id___dxx'
        tab_id=data_manager.query(sql_prepare,TypeSqlDialect.sqlite)
        is_cancel=0
        self.updateProcess.emit(0)
        self.__tab_base = tab_id
        count_row=self.__tab_base.count()
        i=0
        for ft in self.__tab_base.items():

            is_cancel=self.process_callback(i/count_row)
            id_val = ft[name_id]

            i=i+1
            if is_cancel==0:
                break
            if ft.geometry is None:
                continue
            query = findIntersections(tab_id.name, name_id, id_val)
            if query.count() == 0:
                query.close()
                continue
            SplitIntersection(self.__tab_base, query, name_id, id_val)
            query.close()
        tab_id.close()
        self.prepareSignal(False)
        self.prepareParentSignal(True)

        return is_cancel
    @property
    def Params(self):
        return self.__params
    def __isCancel(self):
        self.__cancelProcess=True

    def setCancel(self):
        self.__cancelProcess = True

class ProcessPrepareDelOverShot(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar = Signal(str)
    def __init__(self, params,parent_cls):
        super(ProcessPrepareDelOverShot, self).__init__()
        self.__parent_cls = parent_cls
        self.__params = params
        self.__old_val_progress_local = 0
        self.__name_process='Удаление перелетов'
    def run(self):
        name_table = self.__params['table']
        value_tolerance = self.__params['tolerance']
        unit_len_obj=self.__params['unit']
        isdelOverShot=self.__params['delOvetShot']
        self.prepareSignal(True)
        self.prepareParentSignal(False)
        if not isdelOverShot:
            self.updateFormatProgressBar.emit("Подготовка данных " + "... %p%")
        else:
            self.updateFormatProgressBar.emit(self.__name_process+"... %p%")
        is_cancel = 1
        sql = "Select GeometryType(FromAxiGeo(obj)) as name_geo, * from " + name_table + ' where GeometryType(FromAxiGeo(obj))="GEOMETRYCOLLECTION" or GeometryType(FromAxiGeo(obj))= "MULTILINESTRING"'
        query_tab_update = data_manager.query_hidden(sql, TypeSqlDialect.sqlite)
        #query_tab_update = data_manager.query(sql, TypeSqlDialect.sqlite)
        count_ft=0
        if query_tab_update is not None:
            count_ft=query_tab_update.count()
        if count_ft>0:
            list_remove = []

            tab_base = data_manager.find(name_table)
            cls_cache = CacheTable(tab_base)

            self.updateProcess.emit(0)
            i=-1
            for ft in query_tab_update.items():
                i=i+1
                is_cancel = self.process_callback(i/count_ft)

                if is_cancel == 0:
                    break
                list_remove.append(ft.id)

                count_polyline = len(ft.geometry)
                for j in range(count_polyline):
                    ft_new = FeatureClone(ft, ft.geometry[j])

                    cls_cache.insert(ft_new)
            cls_cache.end()
            if is_cancel>0:
                #self.updateFormatProgressBar.emit("Разбиение коллекций" + "... %p%")
                update_features = []
                for ft_del in query_tab_update.itemsByIds(list_remove):
                    ft_del.geometry = None
                    update_features.append(ft_del)
                query_tab_update.update(update_features)
                query_tab_update.close()
                sql_del = 'Delete From ' + name_table + ' where ObjInfoType(obj)=0'
                query_del = data_manager.query(sql_del, TypeSqlDialect.axioma)
                if isdelOverShot:
                    sql_del_over_shot='Delete From ' + name_table + ' where ObjectLen(obj, "'+unit_len_obj+'")<='+str(value_tolerance)+'and (Str$(obj)<>"Region")'
                    query_del = data_manager.query(sql_del_over_shot, TypeSqlDialect.axioma)
            #if query_tab_update is not None:
            #    query_tab_update.close()

        self.prepareSignal(False)
        self.prepareParentSignal(True)


        return is_cancel
    def __isCancel(self):
        self.__cancelProcess=True

    @property
    def IsCancel(self):
        return self.__cancelProcess
    def setCancel(self):
        self.__cancelProcess = True
    def prepareSignal(self,is_connect=True):
        try:
            self.__parent_cls.cancelProcess.disconnect(self.__isCancel)
        except Exception as ex:
            pass
        if is_connect:
            self.__parent_cls.cancelProcess.connect(self.__isCancel)
            self.__cancelProcess = False
    def prepareParentSignal(self,is_connect=True):
        try:
            self.updateProcess.disconnect(self.__parent_cls.update_progress)
        except Exception as ex:
            pass
        try:
            self.updateFormatProgressBar.disconnect(self.__parent_cls.setFormatprogressBar)
        except Exception:
            pass
        if not is_connect:
            self.updateProcess.connect(self.__parent_cls.update_progress)
            self.updateFormatProgressBar.connect(self.__parent_cls.setFormatprogressBar)
    def process_callback(self, complete_main):

        if self.IsCancel:
            return 0
        cur_progress_int = int(complete_main * 100 + 0.5)
        if cur_progress_int>self.__old_val_progress_local:
                self.__old_val_progress_local = cur_progress_int
                self.updateProcess.emit(complete_main * 100)
        #time.sleep(0.001)
        # self.__parent.window.pr_bar.setValue(complete*100)
        # print(complete*100)
        return 1
class ProcessTempShot(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar = Signal(str)
    def __init__(self, params,parent_cls):
        super(ProcessTempShot, self).__init__()
        self.__parent_cls = parent_cls
        self.__params = params
        self.__old_val_progress_local = 0
        self.__name_process='Удаление перелетов'
    def run(self):
        self.prepareSignal(True)
        self.prepareParentSignal(False)
        self.updateFormatProgressBar.emit(self.__name_process+"... %p%")
        is_cancel=0
        self.updateProcess.emit(0)
        for i in range(100):
            sleep(0.1)
            is_cancel = self.process_callback(i/100)

            if is_cancel == 0:
                break

        self.prepareSignal(False)
        self.prepareParentSignal(True)


        return is_cancel
    def __isCancel(self):
        self.__cancelProcess=True

    @property
    def IsCancel(self):
        return self.__cancelProcess
    def setCancel(self):
        self.__cancelProcess = True
    def prepareSignal(self,is_connect=True):
        try:
            self.__parent_cls.cancelProcess.disconnect(self.__isCancel)
        except Exception as ex:
            pass
        if is_connect:
            self.__parent_cls.cancelProcess.connect(self.__isCancel)
            self.__cancelProcess = False
    def prepareParentSignal(self,is_connect=True):
        try:
            self.updateProcess.disconnect(self.__parent_cls.update_progress)
        except Exception as ex:
            pass
        try:
            self.updateFormatProgressBar.disconnect(self.__parent_cls.setFormatprogressBar)
        except Exception:
            pass
        if not is_connect:
            self.updateProcess.connect(self.__parent_cls.update_progress)
            self.updateFormatProgressBar.connect(self.__parent_cls.setFormatprogressBar)
    def process_callback(self, complete_main):

        if self.IsCancel:
            return 0
        cur_progress_int = int(complete_main * 100 + 0.5)
        if cur_progress_int>self.__old_val_progress_local:
                self.__old_val_progress_local = cur_progress_int
                self.updateProcess.emit(complete_main * 100)
        #time.sleep(0.001)
        # self.__parent.window.pr_bar.setValue(complete*100)
        # print(complete*100)
        return 1
