from time import sleep

from PySide2.QtCore import QObject, Signal
from axipy import data_manager, TypeSqlDialect, UnitValue

from Undershot.ui.process.addTools.clsUnderShot import UnderShotItem
from Undershot.ui.process.addTools.helper_features import getLinerUnit


class ProcessUnderShot(QObject):
    updateProcess = Signal(float)
    updateFormatProgressBar = Signal(str)
    def __init__(self, params,parent_cls):
        super(ProcessUnderShot, self).__init__()
        self.__parent_cls = parent_cls
        self.__params = params
        self.__old_val_progress_local = 0
        self.__name_process='Удаление не доводов'
    def run(self):
        self.__name_table = self.__params['table']
        value_tolerance = self.__params['tolerance']
        unit_len_obj = self.__params['unit']
        self.__distance=UnitValue(value_tolerance,getLinerUnit(unit_len_obj))
        self.prepareSignal(True)
        self.prepareParentSignal(False)
        self.updateFormatProgressBar.emit(self.__name_process+"... %p%")
        is_cancel=0
        self.updateProcess.emit(0)
        #sql_prepare = "Select rowid+1 as id___dxx,* From " + self.__name_table+' where Str$(obj)<>"Region" and IsGeometry(obj)'
        #sql_prepare = "Select RowNum() as id___dxx,* From " + self.__name_table + ' where Str$(obj)<>"Region" and IsGeometry(obj)'
        sql_prepare = "Select RowNum() as id___dxx,* From " + self.__name_table + ' where IsGeometry(obj)'
        name_id = 'id___dxx'
        tab_id = data_manager.query(sql_prepare, TypeSqlDialect.sqlite)
        self.__clsItem = UnderShotItem(tab_id, name_id, self.__distance)
        is_cancel = 0
        self.updateProcess.emit(0)
        count_ft=tab_id.count()
        i=-1
        for ft in tab_id.items():
            i=i+1

            is_cancel = self.process_callback(i/count_ft)

            if is_cancel == 0:
                break
            if ft.geometry is None:
                continue
            list_id_children = self.__clsItem.find(ft)
            if list_id_children is None:
                continue
            self.__clsItem.solver(ft, list_id_children)
        tab_id.close()
        self.updateProcess.emit(100)
        self.prepareSignal(False)
        self.prepareParentSignal(True)


        return is_cancel
    def __isCancel(self):
        self.__cancelProcess=True

    @property
    def IsCancel(self):
        return self.__cancelProcess
    def setCancel(self):
        self.__cancelProcess = True
    def prepareSignal(self,is_connect=True):
        try:
            self.__parent_cls.cancelProcess.disconnect(self.__isCancel)
        except Exception as ex:
            pass
        if is_connect:
            self.__parent_cls.cancelProcess.connect(self.__isCancel)
            self.__cancelProcess = False
    def prepareParentSignal(self,is_connect=True):
        try:
            self.updateProcess.disconnect(self.__parent_cls.update_progress)
        except Exception as ex:
            pass
        try:
            self.updateFormatProgressBar.disconnect(self.__parent_cls.setFormatprogressBar)
        except Exception:
            pass
        if not is_connect:
            self.updateProcess.connect(self.__parent_cls.update_progress)
            self.updateFormatProgressBar.connect(self.__parent_cls.setFormatprogressBar)
    def process_callback(self, complete_main):

        if self.IsCancel:
            return 0
        '''
        cur_progress_int = int(complete_main * 100 + 0.5)
        
        if cur_progress_int>self.__old_val_progress_local:
                self.__old_val_progress_local = cur_progress_int
                self.updateProcess.emit(complete_main * 100)
        '''
        self.updateProcess.emit(complete_main * 100)
        #time.sleep(0.001)
        # self.__parent.window.pr_bar.setValue(complete*100)
        # print(complete*100)
        return 1
